/* 
 * Constantes y variables globales de la app.
 */

var global = {
	// Si se pone a true se activan las trazas mediante console.log
	debug: true,
	// Si se pone a true se reinicia la bbdd en el arranque con datos de prueba
	testData: false,
	// Si se pone a true se desactiva la comunicación con el servidor
	disableServer: true,
	// Guarda la última llamada del servidor para almacenarla en la bbdd, si éste no responde
	ajaxCall: new Object,
	// Longitud minima para el password
	PASSWORD_LENGTH: 4,	
	// Variable que almacena el mes actual del calendario
	mesCalendario:null,
	// Indica si estamos editando o no un valor del calendario
	nuevaDosis:null,
	// Version de la app
	APP_VERSION: '0.9',
	// Salt para concatenar antes de usar md5
	SALT: 'Z8IVe3v7+$H6X,=,)-3o',
	// Ruta donde se encuentra el servidor. Ejemplo: http://servidor/projects/feasan-webapp/index.php
	SERVER_URL: 'http://192.168.1.60/webs/feasan-webapp/index.php',
	// Tiempo de espera de las peticiones ajax antes de devolver error
	SERVER_TIMEOUT: 5000,
	// Tiempo de espera entre cada intento de reconexión de la app con el servidor
	SERVER_RECONNECT: 10000,
};