/* 
 * Capa de datos, encapsula la bbdd y el almacenamiento local.
 */

var dao = {
    // Guarda el perfil en el almacenamiento local
    saveProfile: function(tx) {
        if (global.debug) {
            console.log("saveProfile function");
            console.log("nombre: " + $('#nombre').val());
            console.log("apellidos: " + $('#apellidos').val());
            console.log("sexo: " + $('#sexo').val());
            console.log("fecha nacimiento: " + $('#fechaNacimiento').val());
            console.log("provincia: " + $('#provincia').val());
            console.log("alertas: " + $('#alertas').val());
            console.log("email: " + $('#emailPerfil').val());
            console.log("Hora alertas: " + $('#horaAlertas').val() + ':' + $('#minutoAlertas').val());
        }
        window.localStorage.setItem("nombre", $('#nombre').val());
        window.localStorage.setItem("apellidos", $('#apellidos').val());
        window.localStorage.setItem("sexo", $('#sexo').val());
        window.localStorage.setItem("fechaNacimiento", $('#fechaNacimiento').val());
        window.localStorage.setItem("provincia", $('#provincia').val());
        window.localStorage.setItem("alertas", $('#alertas').val());
        window.localStorage.setItem("email", $('#emailPerfil').val());
        window.localStorage.setItem("lugar", $('#lugar').val());
        window.localStorage.setItem("farmaco", $('#farmaco').val());
        window.localStorage.setItem("min_inr", $('#min_inr').val());
        window.localStorage.setItem("max_inr", $('#max_inr').val());
        window.localStorage.setItem("diagnostico", $('#diagnostico').val());
        //window.localStorage.setItem("horaAlertas", $('#horaAlertas').val());
        /*if ($('#HoraAlertas').val() == '') {
            window.localStorage.setItem("horaAlertas", '12');
            window.localStorage.setItem("minutoAlertas", '00');
        } else {
            window.localStorage.setItem("horaAlertas", $('#HoraAlertas').val());
            window.localStorage.setItem("minutoAlertas", $('#MinutoAlertas').val());
        }*/
		if($('#HoraAlertas').val() != '--' && $('#MinutoAlertas').val() != '--'){
			window.localStorage.setItem("horaAlertas", $('#HoraAlertas').val());
            window.localStorage.setItem("minutoAlertas", $('#MinutoAlertas').val());
		}
        /*if (window.localStorage.getItem("dosisGeneral") == '') {
            window.localStorage.setItem("dosisGeneral", '0');
        }*/
    },
    // Recupera el perfil en el almacenamiento local
    rellenarPerfil: function() {
        if (global.debug) {
            console.log("saveProfile function");
            console.log("nombre: " + window.localStorage.getItem("nombre"));
            console.log("apellidos: " + window.localStorage.getItem("apellidos"));
            console.log("sexo: " + window.localStorage.getItem("sexo"));
            console.log("fecha nacimiento: " + window.localStorage.getItem("fechaNacimiento"));
            console.log("provincia: " + window.localStorage.getItem("provincia"));
            console.log("alertas: " + window.localStorage.getItem("alertas"));
            console.log("email: " + window.localStorage.getItem("email"));
        }
        if (global.debug)
            console.log("rellenarPerfil function");
        $('#nombre').val(window.localStorage.getItem("nombre"));
        $('#apellidos').val(window.localStorage.getItem("apellidos"));
        $('#sexo').val(window.localStorage.getItem("sexo"));
        $('#fechaNacimiento').val(window.localStorage.getItem("fechaNacimiento"));
        $('#provincia').val(window.localStorage.getItem("provincia"));

        $('#lugar').val(window.localStorage.getItem("lugar"));
        $('#farmaco').val(window.localStorage.getItem("farmaco"));
        $('#diagnostico').val(window.localStorage.getItem("diagnostico"));
        $('#min_inr').val(window.localStorage.getItem("min_inr"));
        $('#max_inr').val(window.localStorage.getItem("max_inr"));
        $('#HoraAlertas').val(window.localStorage.getItem("horaAlertas"));
        $('#MinutoAlertas').val(window.localStorage.getItem("minutoAlertas"));

        if (window.localStorage.getItem("alertas") == 1) {
            $('#alertas').addClass('active');
        }
        if (window.localStorage.getItem("email") == 1) {
            $('#emailPerfil').addClass('active');
        }
    },
    // Guarda el email en el almacenamiento local
    saveEmail: function(email) {
        if (global.debug)
            console.log("saveEmail function");

        if (email == null) {
            window.localStorage.removeItem("email");
        } else {
            window.localStorage.setItem("email", email);
            var value = window.localStorage.getItem("email");
            $("#Inicio2MiCorreo").html(value);
        }
    },
    // Devuelve el email almacenado
    getEmail: function() {
        if (global.debug)
            console.log("getEmail: " + window.localStorage.getItem("email"));
        return window.localStorage.getItem("email");
    },
    // Devuelve el email almacenado
    getMinINR: function() {
        var diagnostico = window.localStorage.getItem("diagnostico");
        var diagnostico = window.localStorage.getItem("min_inr");
        if (diagnostico == null)
            diagnostico = 0;
        //Valores minimos
        //El primero es por defecto y no asociado a ningun diagnostico
        //var min = [2, 2, 2, 2.5, 2.5, 2, 2.5];
        var min = [2.5, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5];


        if (global.debug)
            console.log("getMinINR: " + diagnostico);
        return min[diagnostico];
    },
    // Devuelve el email almacenado
    getMaxINR: function() {
        //var diagnostico = window.localStorage.getItem("diagnostico");
        var diagnostico = window.localStorage.getItem("max_inr");
        if (diagnostico == null)
            diagnostico = 0;
        //Valores max
        //El primero es por defecto y no asociado a ningun diagnostico
        //var max = [3, 3, 3, 3.5, 3.5, 3, 3.5];
        var max = [3.5, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5];

        return max[diagnostico];
    },
    // Guarda el password en el almacenamiento local
    savePassword: function(passwd) {
        if (global.debug)
            console.log("savePassword function");

        if (email == null) {
            window.localStorage.removeItem("password");
        } else {
            window.localStorage.setItem("password", passwd);
        }
    },
    // Devuelve el password almacenado
    getPassword: function() {
        if (global.debug)
            console.log("getPassword: " + window.localStorage.getItem("password"));
        return window.localStorage.getItem("password");
    },
    // Última fecha en la que la app se conectó con el servidor
    setLastSync: function(val) {
        window.localStorage.setItem("lastSync", val);
    },
    // Marca la app como actualizada (1) o no actualizada (0) con el servidor
    getLastSync: function() {
        return window.localStorage.getItem("lastSync");
    },
    // Marca la app como actualizada (1) o no actualizada (0) con el servidor
    setUpToDate: function(val) {
        window.localStorage.setItem("upToDate", val);
    },
    // Indica si la app esta actualizada con el servidor
    isUpToDate: function() {
        if (window.localStorage.getItem("upToDate") == '1')
            return true;
        else
            return false;
    },
    // Inicializacion de la bbdd
    populateDB: function(tx) {
        if (global.debug)
            console.log("populateDB function");
        tx.executeSql('CREATE TABLE IF NOT EXISTS Inr (idInr INTEGER PRIMARY KEY, valor REAL, fecha INTEGER)');
        tx.executeSql('CREATE TABLE IF NOT EXISTS Dosis (idDosis INTEGER PRIMARY KEY, valor REAL, fecha INTEGER)');
        tx.executeSql('CREATE TABLE IF NOT EXISTS Revision (idRevision INTEGER PRIMARY KEY, fecha INTEGER)');
        tx.executeSql('CREATE TABLE IF NOT EXISTS Sync (idSync INTEGER PRIMARY KEY, action TEXT, callUrl TEXT, message TEXT)');
        // Test data

        if (global.testData) {
            tx.executeSql('DELETE FROM Inr');
            for (var i = 1; i < 3; i++) {
                var value = Math.floor((Math.random() * 25) + 10) / 10;
                var fecha = new Date(dao.nuevaFecha());
                var mes = fecha.getMonth();
                fecha.setMonth(mes - i);
                for (var j = 0; j < 2; j++) {
                    fecha.setDate(Math.floor((Math.random() * 28) + 1));
                    tx.executeSql('INSERT INTO Inr (valor, fecha) VALUES ("' + value + '", "' + fecha.getTime() + '")');
                }
            }

            tx.executeSql('DELETE FROM Dosis');
            for (var i = 1; i < 5; i++) {
                var value = Math.floor((Math.random() * 25) + 10) / 10;
                var fecha = new Date(dao.nuevaFecha());
                var mes = fecha.getMonth();
                fecha.setMonth(mes - i);
                for (var j = 0; j < 5; j++) {
                    fecha.setDate(Math.floor((Math.random() * 28) + 1));
                    tx.executeSql('INSERT INTO Dosis (valor, fecha) VALUES ("' + value + '", "' + fecha.getTime() + '")');
                }
            }
            tx.executeSql('DELETE FROM Revision');
        }
    },
    // Recupera la informacion para la pagina principal
    pagprincipal: function(tx) {
        if (global.debug)
            console.log("pagprincipal function");
        tx.executeSql('select * from Inr where fecha=(select max(fecha) from Inr)', [], dao.querySuccessInr, dao.errorCB);
    },
    // Recupera la informacion de dosis y revision
    dosis: function(tx) {
        if (global.debug)
            console.log("dosis function");
        var hoy = new Date(dao.nuevaFecha());
        tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) = ' + hoy.getTime(), [], dao.querySuccessDosis, dao.errorCB);
    },
    // Recupera la informacion de revision
    revision: function(tx) {
        if (global.debug)
            console.log("revision function");
        var hoy = new Date(dao.nuevaFecha2());
        tx.executeSql('SELECT * FROM Revision WHERE CAST(fecha AS INTEGER) >= ' + hoy.getTime() + ' ORDER BY fecha ASC', [], dao.querySuccessRevision, dao.errorCB);
    },
    // Recupera todas las dosis del mes indicado
    dosisMes: function(tx) {
        if (global.debug)
            console.log("dosisMes function");
        //var inicioMes = new Date(global.mesCalendario+1);
        var inicioMes = new Date(global.mesCalendario);
        inicioMes.setDate(1);
		inicioMes.setHours(12,0,0,0);
        if (global.debug)
            console.log("dosisMes inicioMes: " + inicioMes);
        //var finMes = new Date(global.mesCalendario+1);
        var finMes = new Date(global.mesCalendario);
        finMes.setDate(dosiscal.daysInMonth(finMes.getMonth(), finMes.getFullYear()));
        if (global.debug)
            console.log("dosisMes finMes: " + finMes);
		//alert("SELECT valor, fecha, strftime('%d',fecha/1000,'unixepoch') AS dia FROM Dosis WHERE CAST(fecha AS INTEGER) BETWEEN " + inicioMes.getTime() + " AND " + finMes.getTime() + " ORDER BY fecha ASC");
        tx.executeSql("SELECT valor, fecha, strftime('%d',fecha/1000,'unixepoch') AS dia FROM Dosis WHERE CAST(fecha AS INTEGER) BETWEEN " + inicioMes.getTime() + " AND " + finMes.getTime() + " ORDER BY fecha ASC", [], dao.querySuccessDosisMes, dao.errorCB);
		
    },
    // Recupera las medias mensuales del valor de Inr de los ultimos 7 meses
    inrMonth: function(tx) {
        if (global.debug)
            console.log("inrMonth function");
        //tx.executeSql("SELECT strftime('%Y',fecha/1000,'unixepoch') as year, strftime('%m',fecha/1000,'unixepoch') as month, avg(valor) as avg, fecha/1000 as fechaMil, strftime('%s', 'now', '-12 months') fechaAtras FROM Inr WHERE CAST(fechaMil AS INTEGER) > CAST(fechaAtras AS INTEGER) GROUP BY strftime('%m%Y',fecha/1000,'unixepoch') ORDER BY fecha", [], dao.queryMonth, dao.errorCB);
        //tx.executeSql("SELECT strftime('%Y',fecha/1000,'unixepoch') as year, strftime('%m',fecha/1000,'unixepoch') as month, strftime('%d',fecha/1000,'unixepoch') as day, valor, fecha/1000 as fechaMil, strftime('%s', 'now', '-12 months') fechaAtras FROM Inr WHERE CAST(fechaMil AS INTEGER) > CAST(fechaAtras AS INTEGER) GROUP BY strftime('%m%Y',fecha/1000,'unixepoch') ORDER BY fecha limit 12", [], dao.queryMonth2, dao.errorCB);
        //tx.executeSql("SELECT strftime('%Y',fecha/1000,'unixepoch') as year, strftime('%m',fecha/1000,'unixepoch') as month, strftime('%d',fecha/1000,'unixepoch') as day, valor, fecha/1000 as fechaMil, strftime('%s', 'now', '-12 months') fechaAtras FROM Inr WHERE CAST(fechaMil AS INTEGER) > CAST(fechaAtras AS INTEGER) ORDER BY fecha limit 20", [], dao.queryMonth2, dao.errorCB);
        tx.executeSql("SELECT strftime('%Y',fecha/1000,'unixepoch') as year, strftime('%m',fecha/1000,'unixepoch') as month, strftime('%d',fecha/1000,'unixepoch') as day, valor, fecha/1000 as fechaMil, strftime('%s', 'now', '-12 months') fechaAtras FROM Inr WHERE CAST(fechaMil AS INTEGER) > CAST(fechaAtras AS INTEGER) ORDER BY fecha DESC limit 6", [], dao.queryMonth2, dao.errorCB);
    },
    // Comprueba si existe un Inr en la fecha indicada, incluye callback
    checkInr: function(tx) {
        if (global.debug)
            console.log("checkInr function. Date: " + $('#fechaActual').html());
        var fecha = new Date(dao.strToDate($('#fechaActual').html()));
        if (global.debug)
            'Fecha de hoy' + fecha.getTime();
        tx.executeSql("SELECT * FROM Inr WHERE CAST(fecha AS INTEGER) = " + fecha.getTime(), [], dao.queryInsertUpdateInr, dao.errorCB);
    },
    // Guarda una llamada ajax en la bbdd para cuando el servidor este caido
    saveAjaxCall: function(tx) {
        if (global.debug)
            console.log("saveAjaxCall function");
        if (global.debug)
            console.log("global.ajaxCall.action: " + global.ajaxCall.action);
        if (global.debug)
            console.log("global.ajaxCall.callUrl: " + global.ajaxCall.callUrl);
        if (global.debug)
            console.log("global.ajaxCall.message: " + global.ajaxCall.message);
        tx.executeSql("INSERT INTO Sync(action, callUrl, message) VALUES ('" + global.ajaxCall.action + "', '" + global.ajaxCall.callUrl + "', '" + global.ajaxCall.message + "')");
    },
    // Borra una llamada ajax en la bbdd cuando esta ya se ha ejecutado
    deleteAjaxCall: function(tx) {
        if (global.debug)
            console.log("deleteAjaxCall function");
        tx.executeSql('DELETE FROM Sync WHERE idSync = (SELECT MIN(idSync) FROM Sync)');
    },
    // Recupera las llamadas ajax de la bbdd para lanzarlas contra el servidor
    checkServer: function(tx) {
        if (global.debug)
            console.log("checkServer function");
        tx.executeSql('SELECT * FROM Sync WHERE idSync = (SELECT MIN(idSync) FROM Sync)', [], dao.checkServerSuccess, dao.errorCB);
    },
    // Introduce un nuevo valor de Inr
    newInr: function(tx) {
        if (global.debug)
            console.log("newInr function");
        var valor = $('#resultado').val();
        var fecha = new Date(dao.strToDate($('#fechaActual').html())).getTime();
        tx.executeSql('INSERT INTO Inr(valor, fecha) VALUES ("' + valor + '", "' + fecha + '")');
        tx.executeSql('SELECT * FROM Inr WHERE fecha = (SELECT MAX(fecha) FROM Inr)', [], dao.querySuccessInr, dao.errorCB);
        // Actualizamos el servidor
        if (!global.disableServer)
            restful.inr('POST', valor, fecha);
        // Actualizamos la portada
        app.db.transaction(dao.pagprincipal, dao.errorCB);
    },
    // Actualiza un valor de Inr existente
    updateInr: function(tx) {
        if (global.debug)
            console.log("updateInr function");
        var valor = $('#resultado').val();
        var fecha = new Date(dao.strToDate($('#fechaActual').html())).getTime();
        tx.executeSql("UPDATE Inr SET valor = " + valor + ", fecha = " + fecha + " WHERE CAST(fecha AS INTEGER) = " + fecha);
        tx.executeSql('SELECT * FROM Inr WHERE fecha = (SELECT MAX(fecha) FROM Inr)', [], dao.querySuccessInr, dao.errorCB);
        // Actualizamos el servidor
        if (!global.disableServer)
            restful.inr('PUT', valor, fecha);
        // Actualizamos la portada
        app.db.transaction(dao.pagprincipal, dao.errorCB);
    },
    // Introduce un nuevo valor de Dosis
    newDosis: function(tx) {
        if (global.debug)
            console.log("newDosis function");
        var hoy = new Date(dao.nuevaFecha());
        var valor = $('#resultado2').val();
        
        var fecha2=new Date(global.mesCalendario);
        fecha2.setHours(12,0,0,0);
        global.mesCalendario=fecha2.getTime();

        if (global.debug) console.log("global.mesCalendario: " + new Date(global.mesCalendario));
        tx.executeSql('INSERT INTO Dosis(valor,fecha) VALUES ("' + valor + '",' + global.mesCalendario + ')');
        tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) = ' + hoy.getTime(), [], dao.querySuccessDosis, dao.errorCB);
        // Actualizamos el servidor
        if (!global.disableServer)
            restful.dosis('POST', valor, global.mesCalendario);
        tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) > ' + hoy.getTime(), [], dao.notificaDosis, dao.errorCB);

    },
    // Actualiza un valor de Dosis
    updateDosis: function(tx) {
        if (global.debug)
            console.log("updateDosis function");
        var hoy = new Date(dao.nuevaFecha());

        var fecha2=new Date(global.mesCalendario);
        fecha2.setHours(12,0,0,0);
        global.mesCalendario=fecha2.getTime();

        if (global.debug) console.log(global.mesCalendario);        
        if (global.debug) console.log(fecha2.getTime());        

        var valor = $('#resultado2').val();
        if (global.debug) console.log("global.mesCalendario: " + new Date(fecha2.getTime()));
        tx.executeSql('UPDATE Dosis SET valor = "' + valor + '" WHERE CAST(fecha AS INTEGER) = ' + global.mesCalendario);
        tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) = ' + hoy.getTime(), [], dao.querySuccessDosis, dao.errorCB);
        // Actualizamos el servidor
        if (!global.disableServer)
            restful.dosis('PUT', valor, global.mesCalendario);
        tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) > ' + hoy.getTime(), [], dao.notificaDosis, dao.errorCB);
    },
    //Notificación para todas las dosis
    todasDosis: new Array(),
    hora: new Array(),
    notificaDosis: function(tx, results) {
        if (global.debug)
            console.log("crea todas las notificaciones de dosis");
        var len = results.rows.length;
        todasDosis = new Array();
        var horaNotificacion = window.localStorage.getItem("horaAlertas") + ':' + window.localStorage.getItem("minutoAlertas");
        hora = horaNotificacion.split(":");
        if (len != 0) {
            for (var a = 0; a < len; a++) {
                var fecha = new Date(results.rows.item(a).fecha);
                todasDosis[a] = new Array();
                todasDosis[a][0] = fecha.getUTCFullYear();
                todasDosis[a][1] = fecha.getUTCMonth();
                todasDosis[a][2] = fecha.getUTCDate();
                todasDosis[a][3] = results.rows.item(a).valor;
            }
        }
        //tx.executeSql("SELECT * fecha FROM Revision ORDER BY fecha ASC", [], dao.creaNotificaciones, dao.errorCB);
        dao.creaNotificaciones();
    },
    // Crea la notificación que se repote diariamente hasta la proxima fecha de revisión
    //creaNotificaciones: function(tx, results) {
    creaNotificaciones: function() {
        if (global.debug)
            console.log("Buscamos la revisión más proxima");
        //var len = results.rows.length;
        var hoy = new Date();
        var hoy2 = new Date();
        hoy = hoy.getUTCFullYear() + hoy.getUTCMonth() + hoy.getUTCDate();
        var fecha = 0;
        var fechaToma=new Date();
        fechaToma.setHours(window.localStorage.getItem("horaAlertas"), window.localStorage.getItem("minutoAlertas"), 0);
        
        window.plugin.notification.local.cancel(2);
        var ahora=new Date();
        if(ahora >= fechaToma)
            fechaToma.setDate(fechaToma.getDate()+1);
        window.plugin.notification.local.add({
            id: 2,
            title: 'Hora de toma',
            message: 'Es hora de tomarse la medicación',
            date: fechaToma,
            repeat: 'daily',
            autoCancel: true
        });
        window.plugin.notification.local.onclick = function (id, state, json) {
            if(id==2){
                app.clickEvent('#tudosis');
            }else{
                app.clickEvent('#turevision');
        		window.plugin.notification.local.cancel(1);
            }
        }
    },
    // Introduce un nuevo valor de Revision
    newRevision: function(tx) {
        if (global.debug)
            console.log("newRevision function");
        if (global.debug)
            console.log("newRevision. Fecha: " + new Date($('#dateRevision').val()));
        // Solo almacenamos una fila en la tabla de revision
        //tx.executeSql('DELETE FROM Revision');
        var fecha = $('#dateRevision').val()
        var fecha = fecha.split('/');
        if (global.debug)
            console.log("Fecha: " + fecha);
        //Corrección android al separar la fecha y la hora en dos campos distintos
        var hora = new Array(2);
        hora[0] = $('#dateRevisionHora').val();
        hora[1] = $('#dateRevisionMinuto').val();
        //var hora =$('#dateRevisionHora').val();
        //var hora= hora.split(':');
        //Creamos la fecha completa
        fecha[1]--;
        var fecha = new Date(fecha[2], fecha[1], fecha[0], hora[0], hora[1], 0, 0);
        //if (global.debug) console.log("Hora: " + hora);

        //var fecha=new Date(fecha.getUTCFullYear(),fecha.getUTCMonth(),fecha.getUTCDate(), hora[0], hora[1], 0, 0);
        var hoy = new Date();
        if (fecha > hoy)
            tx.executeSql('INSERT INTO Revision(fecha) VALUES ("' + fecha.getTime() + '")');
        app.db.transaction(dao.revision, dao.errorCB);
    },
    // Recupera las medias mensuales del valor de Inr de los ultimos 7 meses
    historicoRev: function(tx) {
        if (global.debug)
            console.log("historicoRev function");
        tx.executeSql("SELECT fecha FROM Revision ORDER BY fecha", [], dao.queryHistoricoRev, dao.errorCB);
    },
    // Callback de error en la llamada 
    errorCB: function(tx, err) {
        if (global.debug) {
            if (typeof err === 'object') {
                console.log("Error object: " + JSON.stringify(err));
            } else {
                console.log("Error: " + err);
            }
        }

    },
    // Callback de exito en la llamada 
    successCB: function() {
        if (global.debug)
            console.log("successCB function");
    },
    checkServerSuccess: function(tx, results) {
        if (global.debug)
            console.log("checkServerSuccess function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla Sync: " + len + " filas encontradas.");
        if (len > 0) {
            var action = results.rows.item(0).action;
            var callUrl = results.rows.item(0).callUrl;
            var message = results.rows.item(0).message;
            var response = restful.ajaxCall(action, callUrl, message, false);
        } else {
            // Ya no quedan registros, está todo actualizado.
            dao.setUpToDate('1');
        }
    },
    // Recupera los datos para la pagina principal
    querySuccessInr: function(tx, results) {
        if (global.debug)
            console.log("queryPagPrincipal function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla inr: " + len + " filas encontradas.");
        // La tabla esta vacia
        if (len == 0) {
            var fecha = dao.dateToStr(dao.nuevaFecha());
            $("#tuvalorinr").html("0.0");
            $("#tuinractual").html("0.0");
            $("#fechainr").html(fecha);
            $("#tuineractualfecha").html(fecha);
            $("#fechaActual").html(fecha);
            $("p.muybien.regular").hide();
            $("p.muybien.init").show();
        } else {
            $("p.muybien.init").hide();
            $("p.muybien.regular").show();
            var fecha = dao.dateToStr(new Date(results.rows.item(0).fecha));
            if (global.debug)
                console.log("Inr = " + results.rows.item(0).valor);
            if (global.debug)
                console.log("Id = " + results.rows.item(0).idInr);
            if (global.debug)
                console.log("Fecha = " + fecha);

            var inractualShow = results.rows.item(0).valor;
            if (inractualShow % 1 == 0) {
                inractualShow = inractualShow + '.0';
            }
            //$("#tuvalorinr").html(results.rows.item(0).valor);
            $("#tuvalorinr").html(inractualShow);
            $("#fechainr").html(fecha);
            $("#tuineractualfecha").html(fecha);
            $("#fechaActual").html(fecha);
            $//("#tuinractual").html(results.rows.item(0).valor);
            $("#tuinractual").html(inractualShow);

            /*if (results.rows.item(0).valor < 1.5)
             $("p.muybien.regular").html("Alto riesgo de trombosis o embolias");
             
             else if (results.rows.item(0).valor < 2)
             $("p.muybien.regular").html("Riesgo de trombosis o embolias");
             
             else if (results.rows.item(0).valor < 3)
             $("p.muybien.regular").html("¡Muy bien, sigue así!");
             
             else if (results.rows.item(0).valor >= 3)
             $("p.muybien.regular").html("Consulta a tu médico");
             
             else if (results.rows.item(0).valor > 4)
             $("p.muybien.regular").html("Riesgo de hemorragias");*/

            if (results.rows.item(0).valor <= dao.getMaxINR() && results.rows.item(0).valor >= dao.getMinINR())
                $("p.muybien.regular").html("Estas en rango.<br>¡Muy bien, sigue así!");
            else
                $("p.muybien.regular").html("¡Atención! El valor de tu INR está fuera de tu rango terapéutico.");
        }
    },
    // Decide si se debe modificar el dato de Inr o insertar uno nuevo
    queryInsertUpdateInr: function(tx, results) {
        if (global.debug)
            console.log("queryInsertUpdateInr function");
        var len = results.rows.length;
        if (len > 0) {
            app.db.transaction(dao.updateInr, dao.errorCB);
        } else {
            app.db.transaction(dao.newInr, dao.errorCB);
        }
    },
    // Procesa los datos de la consulta a la tabla de Revision
    querySuccessRevision: function(tx, results) {
        if (global.debug)
            console.log("querySuccessRevision function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla revision: " + len + " filas encontradas.");
        var today = new Date(dao.nuevaFecha2());

        if (len > 0) {
            var fecha = new Date(results.rows.item(0).fecha);

            if (global.debug)
                console.log("Fecha revision = " + results.rows.item(0).fecha);
            // Planificamos la notificacion para un dia antes de la revision
            //var fechaNotificacion = new Date(fecha - (24 * 60 * 60 * 1000));
            var fechaNotificacion = new Date(fecha);
            //fechaNotificacion=fechaNotificacion.setHours(0,0,0);
            fechaNotificacion.setDate(fechaNotificacion.getDate()-1);
			if (global.debug)
                console.log("Fecha Notificacion = " + dao.dateToStr(fechaNotificacion));
            // Mostramos la fecha con el nombre del mes.
            var hours = fecha.getHours();
            if (hours < 10)
                hours = "0" + hours;

            var minutes = fecha.getMinutes();
            if (minutes < 10)
                minutes = "0" + minutes;
            $("#proxRevision").html(dao.dateToStr(fecha, true) + "<br> a las " + hours + ":" + minutes);
            var strFecha = dao.dateToStr(fecha, false, true, true);
            if (global.debug)
                console.log("strFecha = " + strFecha);
            $("#dateRevision").val(strFecha);
            //Comentado hasta que se solucione
            window.plugin.notification.local.add({
                id: 1,
                title: 'Recordatorio',
                message: 'Mañana control INR', //+dao.dateToStr(fecha),
                date: fechaNotificacion,
                autoCancel: true
            });
            window.plugin.notification.local.onclick = function (id, state, json) {
                if(id==2){
                    app.clickEvent('#tudosis');
                }else{
                    app.clickEvent('#turevision');
            		window.plugin.notification.local.cancel(1);
                }
            }
            //}, app.clickEvent("#turevision"));
        } else {
            $("#dateRevision").val(dao.dateToStr(today, false, true));
        }

    },
    queryHistoricoRev: function(tx, results) {
        if (global.debug)
            console.log("queryHistoricoRev function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla revision: " + len + " filas encontradas.");
        var today = new Date(dao.nuevaFecha());
        var content = "";
        for (var i = 0; i < len; i++) {
            var fecha = new Date(results.rows.item(i).fecha);
            if (global.debug)
                console.log("Fecha revision = " + results.rows.item(i).fecha);
            var hours = fecha.getHours();
            if (hours < 10)
                hours = "0" + hours;

            var minutes = fecha.getMinutes();
            if (minutes < 10)
                minutes = "0" + minutes;

            var month = fecha.getMonth() + 1;
            if (month < 10)
                month = "0" + month;

            var day = fecha.getDate();
            if (day < 10)
                day = "0" + day;


            var html = '<div class="calendario-dia">';
            html += '<span class="fecha-diames">' + day + '</span>';
            html += '<span class="fecha-diasemana">' + dosiscal.meses[fecha.getMonth()] + ' ' + (fecha.getYear() + 1900) + ' a las ' + hours + ':' + minutes + '</span>';
            html += '</div>';
            content += html;
        }
        $("#listarevisiones").html(content);

    },
    // Procesa los datos de la consulta a la tabla de Dosis
    querySuccessDosis: function(tx, results) {
        if (global.debug)
            console.log("querySuccessDosis function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla dosis: " + len + " filas encontradas.");
        //$('#resultado2').val('');
        if (len > 0) {
            if (global.debug)
                console.log("Dosis = " + results.rows.item(0).valor);
            if (results.rows.item(0).valor % 1 == 0) {
                $("#dosisactual").html(results.rows.item(0).valor + '.0');
				window.localStorage.setItem("dosisGeneral",results.rows.item(0).valor + '.0');
            } else {
                $("#dosisactual").html(results.rows.item(0).valor);
				window.localStorage.setItem("dosisGeneral",results.rows.item(0).valor);
            }
        } else {
			//var hoy = new Date(dao.nuevaFecha()) ;
			var hoy = new Date();
            //tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) <= '+hoy.getTime()+' ORDER BY fecha DESC LIMIT 1', [], dao.querySuccessDosis, dao.errorCB);
			$("#dosisactual").html(window.localStorage.getItem("dosisGeneral"));
            /*if (global.debug)
             console.log("dosis function");
             if (window.localStorage.getItem("dosisGeneral") != null) {
             if (window.localStorage.getItem("dosisGeneral") % 1 == 0) {
             $("#dosisactual").html(window.localStorage.getItem("dosisGeneral") + '.0');
             } else {
             $("#dosisactual").html(window.localStorage.getItem("dosisGeneral"));
             }
             } else {
             $("#dosisactual").html(window.localStorage.setItem("dosisGeneral", '0'));
             }*/
            //var hoy = new Date(dao.nuevaFecha()) ;
            //tx.executeSql('SELECT * FROM Dosis WHERE CAST(fecha AS INTEGER) < '+hoy.getTime()+' ORDER BY fecha DESC LIMIT 1', [], dao.querySuccessDosis1, dao.errorCB);
        }
        $('#fechaDosis').html(window.localStorage.getItem("horaAlertas") + ':' + window.localStorage.getItem("minutoAlertas"));
    },
    /*querySuccessDosis1: function(tx, results){
     if (global.debug) console.log("querySuccessDosis function");
     var len = results.rows.length;
     if (global.debug) console.log("Tabla dosis: " + len + " filas encontradas.");
     //$('#resultado2').val('');window.localStorage.setItem("apellidos", $('#apellidos').val());
     if(len > 0) {
     if (global.debug) console.log("Dosis = " + results.rows.item(0).valor);
     if(results.rows.item(0).valor % 1==0){
     $("#dosisactual").html(results.rows.item(0).valor+'.0');
     }else{
     $("#dosisactual").html(results.rows.item(0).valor);
     }
     } else {
     $("#dosisactual").html('0.0');
     }
     },*/

    // Procesa los datos de la consulta de las Dosis de un mes
    querySuccessDosisMes: function(tx, results) {
        if (global.debug)
            console.log("querySuccessDosisMes function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla dosis (mes): " + len + " filas encontradas.");
        var diaMes = new Date(global.mesCalendario);
        diaMes.setDate(1);
        diaMes.setHours(0,0,0);
        var mes = new Array();
        var daysInMonth = dosiscal.daysInMonth(diaMes.getMonth(), diaMes.getFullYear());
        var j = 0;
        for (var i = 0; i < daysInMonth; i++) {
            var dia = new Object();
            // numero de dia del mes (1-31)
            dia.diaMes = diaMes.getDate();
            // numero de dia de la semana (0-6)
            dia.diaSemana = diaMes.getDay();
            /*
            if (global.debug)
                console.log("dia: " + dia.diaMes);
            if (j < len && global.debug)
                console.log("dia dato: " + results.rows.item(j).dia);
			*/
            if (j < len && results.rows.item(j).dia == dia.diaMes) {
                // dosis de ese dia
                dia.dosis = results.rows.item(j).valor;
                j++;
            } else {
                dia.dosis = null;
            }
            /*
            if (global.debug)
                console.log("querySuccessDosisMes dia.diaMes: " + dia.diaMes);
            if (global.debug)
                console.log("querySuccessDosisMes dia.diaSemana: " + dia.diaSemana);
            if (global.debug)
                console.log("querySuccessDosisMes dia.dosis: " + dia.dosis);
            */
            if (global.debug)
                console.log("Dia " + dia.diaMes + " | DiaSemana " + dia.diaSemana + " | Dosis " + dia.dosis);
            mes.push(dia);
            diaMes.setDate(diaMes.getDate() + 1);
        }
        dosiscal.dibujarCalendario(mes);
    },
    // Procesa los datos para mostrar la grafica2
    queryMonth2: function(tx, results) {
        //vaciamos la grafica
        $('.contentGrafica').empty();
        $('.bottomGrafica').empty();
        $('.contentGrafica').append('<hr class="minINR" />');
        $('.contentGrafica').append('<hr class="maxINR" />');
        //Creamos el array donde vamos a guardar todos los puntos
        var bolas = new Array();
        var len = results.rows.length;
        for (i = 0; i <= 11; i++) {
            if (i < len){
                var valor = results.rows.item(i).valor;
                var fechaGrafica = new Date(results.rows.item(i).year, results.rows.item(i).month - 1, results.rows.item(i).day);
                bolas.push([fechaGrafica, valor]);
            }
        }

        //altura de la linea y altura de la grafica
        //var cadaLinea=($(document).height() - 190)/7;
        var cadaLinea=($(document).height() - 190)/16;
        //var cadaLinea=($(document).height() - 95)/16;
        var cadaLinea=$('#leftGrafica span').height();
        var altura=$(document).height() - 190;
        //mininr
        var diagnostico = window.localStorage.getItem("min_inr");
        if (diagnostico == null)
            diagnostico = 3;
        else
            diagnostico=parseInt(diagnostico)+3;
        //$('.minINR').css('top', altura-(diagnostico*cadaLinea+15));
        //$('.minINR').css('top', altura-((diagnostico*2)*cadaLinea+10));
        //$('.minINR').css('top', altura-(diagnostico*cadaLinea-40));
        //$('.minINR').css('top', (altura-(diagnostico*cadaLinea)+(cadaLinea/2))+9);
        $('.minINR').css('top', (altura-(diagnostico*cadaLinea)+(cadaLinea)));
        //maxinr
        var diagnostico = window.localStorage.getItem("max_inr");
        if (diagnostico == null)
            diagnostico = 5;
        else
            diagnostico=parseInt(diagnostico)+3;
        //$('.maxINR').css('top', (altura-(diagnostico*cadaLinea)+(cadaLinea/2))+9);
        $('.maxINR').css('top', (altura-(diagnostico*cadaLinea)+(cadaLinea)));
        //$('.maxINR').css('top', altura-(diagnostico*cadaLinea)+15);
        //Bola azul y roja
        var blue='<div class="bolaBlue"></div>';
        var red='<div class="bolaRed"></div>';
        var mes = ['ENE', 'FEB', 'MAR', 'ABR', 'MAY', 'JUN', 'JUL', 'AGO', 'SEP', 'OCT', 'NOV', 'DIC'];
        var a=0;
        for (i = bolas.length-1; i >= 0; i--) {
        //for (i = 0; i <= bolas.length; i++) {

            var cuanto=(bolas[i][1] - 1)/0.5;
            var cuanto=(bolas[i][1])/0.5;
            var donde1=cuanto*cadaLinea;
            //var donde1=(cuanto*cadaLinea+25);
            //var donde2=(i*50)+17;
            var donde2=a*$('.fechaGraf').width();
            //if(i==0)
            //    var donde2=a*$('.fechaGraf').width();
            var margin="0px";
            //if(bolas[i][1]==8)
                //margin="-5px";
            var dif=8;
            if(bolas[i][1]>=dao.getMinINR() && bolas[i][1]<=dao.getMaxINR()){
                $('.contentGrafica').append('<div class="bolaBlue" style="margin-bottom: '+margin+'; bottom: '+(donde1-dif)+'px; left: '+donde2+'px;"></div>');
            }else{
                $('.contentGrafica').append('<div class="bolaRed" style="margin-bottom: '+margin+'; bottom: '+(donde1-dif)+'px; left: '+donde2+'px;"></div>');
            }
            var fecha=new Date(bolas[i][0]);
            $('.bottomGrafica').append('<div class="fechaGraf"><span class="diaGraf">'+fecha.getDate()+'</span><span class="mesGraf">'+mes[fecha.getMonth()]+'</span><span class="yearGraf">'+fecha.getFullYear()+'</span></div>');
            a++;
        }
    },
    historicoInr: function(tx){
        tx.executeSql("SELECT valor, fecha FROM Inr ORDER BY fecha DESC limit 50", [], dao.historicoInrData, dao.errorCB);
    },
    historicoInrData: function (tx, results){
        var data=new Array();
        var len = results.rows.length;
        for (i = 0; i < len; i++) {
            var valor= results.rows.item(i).valor;
            var fecha=new Date(results.rows.item(i).fecha);
            fecha=fecha.getDate()+'/'+ (fecha.getMonth()+1) +'/'+fecha.getFullYear();
            data.push([fecha, valor]);
        }
        var html='<ul>';
        for (i = 0; i < len; i++) {
            html+="<li><span class='histInt'>"+data[i][0]+"</span><span class='fechaValInr'>"+data[i][1]+"</span></li>";
        }
        html+='</ul>';
        $('#mininrcontenido').empty();
        $('#mininrcontenido').append(html);
    },
    // Procesa los datos para mostrar la grafica
    queryMonth: function(tx, results) {
        if (global.debug)
            console.log("queryMonth function");
        var len = results.rows.length;
        if (global.debug)
            console.log("Tabla inr(fecha): " + len + " filas encontradas.");
        var data = new Array();
        var redDots = new Array();
        var blueDots = new Array();
        var maxLine = new Array();
        var minLine = new Array();

        var minINR = dao.getMinINR();
        var maxINR = dao.getMaxINR();

        var fechaInicial = new Date(dao.nuevaFecha());
        fechaInicial.setMonth(new Date().getMonth() - 11);
        fechaInicial.setDate(1);

        var j = 0;
        for (i = 0; i <= 12; i++) {
            if (i < (11 - len)) {
                var avg = 2.5;
                var fechaGrafica = new Date(fechaInicial);
                fechaInicial.setMonth(fechaGrafica.getMonth() + 1);
                
            } else {
                if (j >= len)
                    break;
                var avg = results.rows.item(j).avg;
                //var fechaGrafica = new Date(results.rows.item(j).year, results.rows.item(j).month - 1, 1);
                var fechaGrafica = new Date(results.rows.item(j).year, results.rows.item(j).month - 1);
                //fechaGrafica.setDate(results.rows.item(j).day);
                //var fechaGrafica = new Date(results.rows.item(j).year, results.rows.item(j).month - 1, results.rows.item(j).day);
                if (i != 0) {
                    if (global.debug)
                        console.log("Datos grafica. Añadido punto azul. i: " + i);
                    blueDots.push([fechaGrafica, avg]);
                }
                j++;
            }
            data.push([fechaGrafica, avg]);

            minLine.push([fechaGrafica, minINR]);
            maxLine.push([fechaGrafica, maxINR]);

            if ((avg > maxINR || avg < minINR) && (i != 0)) {
                if (global.debug)
                    console.log("Datos grafica. Añadido punto rojo. i: " + i);
                redDots.push([fechaGrafica, avg]);
            }
            if (global.debug)
                console.log("Datos grafica. Fecha: " + fechaGrafica);
            if (global.debug)
                console.log("Datos grafica. Media: " + avg);
        }

        // El ultimo valor siempre es 2.5, es el que se sale por la derecha de la grafica
        var avg = 2.5;
        var hoy = new Date(dao.nuevaFecha());
        var ultimaFecha = new Date(hoy.getFullYear(), hoy.getMonth() + 1, 1);
        //fechaGrafica.setDate(5);
        if (global.debug)
            console.log("Datos grafica (ultimo). Fecha: " + ultimaFecha);
        if (global.debug)
            console.log("Datos grafica (ultimo). Media: " + avg);
        data.push([ultimaFecha, avg]);

        minLine.push([ultimaFecha, minINR]);
        maxLine.push([ultimaFecha, maxINR]);

        graph.show(data, blueDots, redDots, minLine, maxLine);
    },
    // Devuelve la fecha de hoy sin informacion de la hora
    nuevaFecha: function() {
        return new Date().setHours(12,0,0);
        //return new Date().setMinutes(00);
        //return new Date().setSeconds(00);
        //return new Date().setHours(12, 0, 0, 0);
    },
    nuevaFecha2: function() {
        return new Date().setHours(0);
        //return new Date().setHours(12, 0, 0, 0);
    },
    // Convierte una cadena de fecha dd/mm/yyyy en un UNIX timestamp
    strToDate: function(str) {
        if (global.debug)
            console.log("strToDate: " + str);
        var dateArray = str.split('/');
        var fecha = new Date(dateArray[2], dateArray[1] - 1, dateArray[0], 12, 0, 0, 0);
        return fecha.getTime();
    },
    dosisGeneral: function(val) {
        if (global.debug)
            console.log("strToDate: " + val);
        window.localStorage.setItem("dosisGeneral", val);
        var dosis = window.localStorage.getItem("dosisGeneral");
        if (dosis % 1 == 0)
            dosis = dosis + '.0';
        if(window.localStorage.getItem("horaAlertas")== null){
            $('#fechaDosis').html("--:--");
        }else{
            $('#fechaDosis').html(window.localStorage.getItem("horaAlertas") + ':' + window.localStorage.getItem("minutoAlertas"));
        }
        $('#dosisactual').html(dosis);
    },
    // Convierte un objeto fecha en una cadena de fecha de formato dd/mm/yyyy o bien dd - mes - yyyy
    // Si es canonical devuelve yyyy-mm-dd para los input de tipo fecha que necesitan este formato
    dateToStr: function(date, monthNames, canonical, showTime) {
        if (global.debug)
            console.log("dateToStr: " + date);
        var fecha = new Date(date);
        if (monthNames == true) {
            var meses = ['', 'Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
            return fecha.getDate() + ' - ' + meses[fecha.getMonth() + 1] + ' - ' + fecha.getFullYear();
        } else {
            var month = fecha.getMonth() + 1;
            if (month < 10)
                month = "0" + month;

            var day = fecha.getDate();
            if (day < 10)
                day = "0" + day;

            if (canonical) {
                if (showTime) {
                    var hours = fecha.getHours();
                    if (hours < 10)
                        hours = "0" + hours;

                    var minutes = fecha.getMinutes();
                    if (minutes < 10)
                        minutes = "0" + minutes;
                    return fecha.getFullYear() + '-' + month + '-' + day + "T" + hours + ':' + minutes;
                } else
                    return fecha.getFullYear() + '-' + month + '-' + day;
            } else {
                if (showTime) {
                    var hours = fecha.getHours();
                    if (hours < 10)
                        hours = "0" + hours;

                    var minutes = fecha.getMinutes();
                    if (minutes < 10)
                        minutes = "0" + minutes;

                    return day + '/' + month + '/' + fecha.getFullYear() + ' ' + hours + ':' + minutes;
                } else {
                    return day + '/' + month + '/' + fecha.getFullYear();
                }
            }
        }
    },
};
