/* 
 * Validaciones.
 */

var val = {
	// Realiza las verificaciones de los campos
    verifyRequirements: function(data_to_verify){
		var result=true;
    	if(data_to_verify!=undefined){
	    	var elems= data_to_verify.split(" ");
	    	var verified = true;
	    	for(i=0; i< elems.length; i++){
				var e=elems[i];
				elems[i]=e.trim();
				if ($("#"+elems[i]).attr("validation") == "required" && $("#"+elems[i]).val()==''){
					verified = false;
				}
				if ($("#"+elems[i]).attr("validation") == "email" && val.validateEmail($("#"+elems[i]).val()) == false) {
					verified = false;
				}
				// Contraseña de al menos 4 caracteres (por ejemplo)
				if ($("#"+elems[i]).attr("validation") == "password" && $("#"+elems[i]).val().length < global.PASSWORD_LENGTH) {
					verified = false;
				}
				if ($("#"+elems[i]).attr("validation") == "past-date" && val.validatePastDate($("#"+elems[i]).val()) == false) {
					verified = false;
				}
				if ($("#"+elems[i]).attr("validation") == "future-date" && val.validateFutureDate($("#"+elems[i]).val()) == false)
				{
					verified = false;
				}
				if (verified) {
					return true ;
				}
				else {
					navigator.notification.alert(
			            $("#"+elems[i]).attr("data-message-alert"),	// message
			            null,         								// callback
			            'Error',            						// title
			            'Aceptar'									// buttonName
			        );					
					return false;
				}
			}
		}
		return result;	
    },
	// Comprueba si el email es valido
	validateEmail: function(email) { 
		var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		return re.test(email);
	}, 	
	// Comprueba que la fecha es anterior a hoy
	validatePastDate: function(date) { 
		var today = new Date(dao.nuevaFecha());
		var fecha = new Date(date);
		if (fecha.getTime() > today.getTime()) {
			return false;				
		} else { 
			return true;
		}
	},
	// Comprueba que la fecha es posterior a hoy
	validateFutureDate: function(date) { 
		return !val.validatePastDate(date);
	},
};