/* 
 * Capa de datos, encapsula la bbdd y el almacenamiento local.
 */

var dosiscal = {
    meses: ['Ene', 'Feb', 'Mar', 'Abr', 'May', 'Jun', 'Jul', 'Ago', 'Sep', 'Oct', 'Nov', 'Dic'],
    //meses: ['Ene','Feb','Mar','Abr','May','Jun','Jul','Ago','Sep','Oct','Nov','Dic'],
    diasSemana: ['DOM', 'LUN', 'MAR', 'MIE', 'JUE', 'VIE', 'SÁB'],
    //diasSemana: ['DOMINGO','LUNES','MARTES','MIERCOLES','JUEVES','VIERNES','SÁBADO'],
    count: 0,
    dibujarCalendario: function(datos) {
        this.count++;
        $('#calendario-dosis-listadias').html('');
        var content = "";
        for (var i = 0; i < datos.length; i++) {
            var dia = datos[i];
            var html = '<div id="' + this.count + "_" + dia.diaMes + '" class="calendario-dia">';
            html += '<span class="fecha-diames">' + dia.diaMes + '</span>';
            html += '<span class="fecha-diasemana">' + dosiscal.diasSemana[dia.diaSemana] + '</span>';
            if (dia.dosis != null) {
                var dosiscorrect = dia.dosis;
                if (dosiscorrect % 1 == 0)
                    if(dosiscorrect!=0)
                        dosiscorrect = dosiscorrect + '.0';
                html += '<span class="fecha-dosis" data-nuevo="0"><span>' + dosiscorrect + '</span><img src="img/dosiscal.png"/></span>';
            } else {
                /*var dosiscorrect = window.localStorage.getItem("dosisGeneral");
                if (dosiscorrect % 1 == 0)
                    if(dosiscorrect!=0)
                        dosiscorrect = dosiscorrect + '.0';*/
                dosiscorrect='0.0';
                html += '<span class="fecha-dosis" data-nuevo="1"><span>' + dosiscorrect + '</span><img src="img/dosiscal.png"/></span>';
            }
            html += '</div>';
            content += html;
            $('#calendario-dosis-listadias').append(html);
            //if (global.debug) console.log("************ " + '#' + this.count + "_" + dia.diaMes);

            $('#' + this.count + "_" + dia.diaMes).click(function() {
                if (global.debug) console.log("---------->" + $(this).attr('id'));
                global.mesCalendario = new Date(global.mesCalendario).setDate($(this).attr('id').split("_")[1]);
                //global.mesCalendario = new Date(global.mesCalendario).setHours(0,0,0);
                if (global.debug) console.log("global.mesCalendario: " + new Date(global.mesCalendario));
                if ($(this).has('span.fecha-dosis').length != 0) {
                    if (global.debug) console.log("Dosis: " + $(this).find('span.fecha-dosis span').html());
                    //$('#resultado2').attr('placeholder', $(this).find('span.fecha-dosis span').html());
                    var id = $(this).attr('id');
                    if ($('#' + id + ' span.fecha-dosis').attr('data-nuevo') == 1) {
                        global.nuevaDosis = true;
                    } else {
                        global.nuevaDosis = false;
                    }
                } else {
                    if (global.debug) console.log("$(this).has('span.fecha-dosis') == false");
                    $('#resultado2').attr('placeholder', '');
                    var id = $(this).attr('id');
                    if ($('#' + id + ' span.fecha-dosis').attr('data-nuevo') == 1) {
                        global.nuevaDosis = true;
                    } else {
                        global.nuevaDosis = false;
                    }
                }
                Artres.keyboard.show('#resultado2', 3);
                app.clickEvent('#introdosis');
            });

        }
        $('#calendario-dosis-listadias').append('&nbsp;&nbsp;');
        $('#calendario-dosis-mes').html(dosiscal.meses[new Date(global.mesCalendario).getMonth()]+' '+new Date(global.mesCalendario).getFullYear());
        var alturaActual = $(window).outerHeight() - $('#listadosis .navegation').outerHeight() - $('#calendario-dosis-mes').outerHeight();
        $('#scroll-calendario').outerHeight(alturaActual);
        if(app.isScroll==0){
            setTimeout(function() {
                var myScroll = new iScroll('scroll-calendario');
                app.isScroll=1;
            }, 1000);
        }
    },
    daysInMonth: function(month, year) {
        return new Date(year, month + 1, 0).getDate();
    },
};