/* 
 * Graficas.
 */

var graph = {
	show: function(graphData, blueDots, redDots, minLine, maxLine){
		if (global.debug) console.log("showGrafica function");
		var container = document.getElementById("grafica");
		// var graphData = new Array() ;
		
		// A couple flotr configuration options:
		var options = {
			colors: ['#bbf3f7', '#01b3fb', '#01b3fb', '#ff5d5e'],
			xaxis: {
				mode : 'time',
				noTicks: 12,
				timeFormat : '<div class="graph-month">%b</div><div class="graph-year">%y</div>',
				margin: false
			}, 
			yaxis: {
				min: 1,
				max: 4.5
			},
			selection : {
				mode : 'x'
			},
			grid : {
				verticalLines : false,
				outlineWidth: 0,
			},
            selection: {
                color: '#B6D9FF',
            },
		};
		
		var i, x, o, graphic;

		// Draw the graph:
		graphic = Flotr.draw(
			container, [
				{data:graphData, lines:{fill:true}},
                {data:minLine, lines:{fill:false, color:'#ff5d5e', lineWidth:1}},
                {data:maxLine, lines:{fill:false, color:'#ff5d5e', lineWidth:1}},
				{data:graphData, lines: {show: true, color:'#01b3fb'}, points: {show: false}},	
				{data:blueDots, points: {show: true, radius:10, fill: true, fillColor: '#01b3fb'}},
				{data:redDots, points: {show: true, radius:10, fill: true, fillColor: '#ff5d5e'}},				
			],// Array of data series
			options     // Configuration options
		);
	}
};